//! Extensions
use super::*;
use std::{
    iter::{self, Fuse,}
};
pub trait TaekTwoExt: Iterator
{
    fn take_two(self) -> TakeTwo<Self>;
}

#[derive(Debug, Clone)]
pub struct TakeTwo<I: ?Sized + Iterator>(I);

impl<T, I: Iterator<Item=T> + ?Sized> Iterator for TakeTwo<I>
{
    type Item = (T, Option<T>);
    #[inline] 
    fn next(&mut self) -> Option<Self::Item>
    {
	let first = self.0.next()?;
	Some((first, self.0.next()))
    }
}

impl<I: Iterator> TaekTwoExt for I
where I: Iterator + Sized
{
    #[inline] 
    fn take_two(self) -> TakeTwo<Self> {
	TakeTwo(self)
    }
}
